/**
 * Base class of functions used in features (e.g. substr())
 */
#ifndef _FEATURE_FUNCTION_H_
#define _FEATURE_FUNCTION_H_

#include <config.h>

#include <assert.h>
#include <string>
#include "Dictionary.h"
#include "WordBuffer.h"

const int FUNCTION_ROW = 1;
const int FUNCTION_COLUMN = 2;
const int FUNCTION_TRANSFORM = 3;

class FeatureFunction {
protected:
	Dictionary *dict;
	WordBuffer *wb;

public:
	FeatureFunction(Dictionary *dict, WordBuffer *wb);
	virtual ~FeatureFunction() {};

	virtual int getType() = 0;
	virtual const char *getName() = 0;

	string *toString();
};

inline FeatureFunction::FeatureFunction(Dictionary *dict, WordBuffer *wb) {
	this->dict = dict;
	this->wb = wb;
}

#endif
