/**
 * Base class of functions used in features (e.g. substr())
 */
#ifndef _FEATURE_FUNCTION_COLUMN_H_
#define _FEATURE_FUNCTION_COLUMN_H_

#include <config.h>

#include <string>
#include "FeatureFunction.h"

class FeatureFunctionColumn : public FeatureFunction {
public:
	FeatureFunctionColumn(Dictionary *dict, WordBuffer *wb) : FeatureFunction(dict, wb) {};
	virtual ~FeatureFunctionColumn() {};

	int getType();
	virtual const char *getName() = 0;
	virtual int getValue(int origRow, int row, bool useCorrectTags) = 0;

	string *toString();
};

inline int FeatureFunctionColumn::getType() {
	return FUNCTION_COLUMN;
}

#endif
