/**
 * Base class of functions used in features (e.g. substr())
 */
#ifndef _FEATURE_FUNCTION_ROW_H_
#define _FEATURE_FUNCTION_ROW_H_

#include <config.h>

#include <string>
#include "FeatureFunction.h"

class FeatureFunctionRow : public FeatureFunction {
public:
	FeatureFunctionRow(Dictionary *dict, WordBuffer *wb) : FeatureFunction(dict, wb) {};
	virtual ~FeatureFunctionRow() {};

	int getType();
	virtual const char *getName() = 0;
	virtual void getTagContextSize(int *min, int *max) = 0;
	virtual int getRow(int origRow, bool useCorrectTags) = 0;

	string *toString();
};

inline int FeatureFunctionRow::getType() {
	return FUNCTION_ROW;
}

#endif
