/**
 * Base class of functions used in features (e.g. substr())
 */
#ifndef _FEATURE_FUNCTION_TRANSFORM_H_
#define _FEATURE_FUNCTION_TRANSFORM_H_

#include <config.h>

#include <string>
#include "FeatureFunction.h"

class FeatureFunctionTransform : public FeatureFunction {
public:
	FeatureFunctionTransform(Dictionary *dict, WordBuffer *wb) : FeatureFunction(dict, wb) {};
	virtual ~FeatureFunctionTransform() {};

	int getType();
	virtual const char *getName() = 0;
	virtual int transformValue(int value, bool useCorrectTags) = 0;

	string *toString();
};

inline int FeatureFunctionTransform::getType() {
	return FUNCTION_TRANSFORM;
}

#endif
