/**
 * GuidedLeraning: implementation of Libin Shen's algorithm for tagging
 */
#ifndef _GUIDED_LEARNING_H_
#define _GUIDED_LEARNING_H_

#include <config.h>

#include <string>
#include "Dictionary.h"
#include "Features.h"
#include "Span.h"
#include "WordBuffer.h"

using namespace std;

class GuidedLearning {
	Dictionary *dict;
	WordBuffer *wb;

	// spans covering the sentence
	vector<Span*> spans;
public:
	GuidedLearning(Dictionary *dict, WordBuffer *wb, int beamWidth, int interfaceSize);
	~GuidedLearning();

	void tagSentence(Features *ftrs);
	void trainSentence(Features *ftrs);

	string *toString();
};

#endif
