#include <config.h>

#include "common.h"

bool isComment(const char *s) {
	while (isspace(*s))
		s++;
	if (*s == '#')
		return true;
	return false;
}

bool isEmpty(const char *s) {
	while (isspace(*s))
		s++;
	return *s ? false : true;
}

int countChars(const char *s, char c) {
	int count = 0;
	while ((s = strchr(s, c))) {
		s++;
		count++;
	}
	return count;
}

char *skipWhiteSpace(char *s) {
	while (isspace(*s))
		s++;
	return s;
}

int readInt(char **str) {
	char *s = *str;
	int neg = 1;
	int n = 0;
	if (*s == '+') {
		s++;
	} else if (*s == '-') {
		neg = -1;
		s++;
	}
	if (*s < '0' || *s > '9')
		return 0;
	while (*s >= '0' && *s <= '9') {
		n = n*10 + (*s-'0');
		s++;
	}
	*str = s;
	return neg*n;
}

void chomp(char *s) {
	int i = strlen(s)-1;
	while (i >= 0 && (s[i] == '\r' || s[i] == '\n')) {
		s[i] = '\0';
		i--;
	}
}
