/**
 * For simplicity (and performance reasons) we do not
 */

#include <config.h>

#include <stdio.h>
#include <string>
#include "../common.h"
#include "FeatureFunctionMask.h"

FeatureFunctionMask::FeatureFunctionMask(Dictionary *dict, WordBuffer *wb, const char *args) : FeatureFunctionTransform(dict, wb) {
	// get name of a function (e.g. substr)
	name = (char *)malloc(sizeof("Mask")+sizeof(args)+3);
	strcpy(name, "Mask(");
	strcat(name, args);
	strcat(name, ")");
	// count number of '1' in the mask
	mask = strdup(args);
	maskLen = strlen(mask);
	tmpBuffer = new char[maskLen+1];
}

FeatureFunctionMask::~FeatureFunctionMask() {
	free(name);
	free(mask);
	delete[] tmpBuffer;
}

const char *FeatureFunctionMask::getName() {
	return name;
}

int FeatureFunctionMask::transformValue(int value, bool useCorrectTags) {
	tr1::unordered_map<int, int>::iterator iter = cache.find(value);
	if (iter != cache.end()) {
		return iter->second;
	} else {
		int result;
		if (value == DICTIONARY_NULL) {
			result = DICTIONARY_NULL;
		} else if (value == DICTIONARY_UNKNOWN) {
			result = DICTIONARY_UNKNOWN;
		} else {
			const char *s = dict->getString(value);
			int j = 0;
			for (int i = 0; *s && i < maskLen; i++, s++) {
				if (mask[i] == '1')
					tmpBuffer[j++] = *s;
			}
			tmpBuffer[j] = '\0';
			result = dict->getId(tmpBuffer, true);
		}
		cache[value] = result;
		return result;
	}
}
