/**
 * For simplicity (and performance reasons) we do not
 */

#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <limits>
#include <string>
#include "../common.h"
#include "FeatureFunctionParent.h"

FeatureFunctionParent::FeatureFunctionParent(Dictionary *dict, WordBuffer *wb, const char *args) : FeatureFunctionRow(dict, wb) {
}

FeatureFunctionParent::~FeatureFunctionParent() {
}

const char *FeatureFunctionParent::getName() {
	return "Parent()";
}

void FeatureFunctionParent::getTagContextSize(int *min, int *max) {
	*min = std::numeric_limits<int>::min();
}

int FeatureFunctionParent::getRow(int origRow, bool useCorrectTags) {
	int tag = useCorrectTags ? wb->getCorrectTagValue(origRow) : wb->getProposedTagValue(origRow);
	int parentIndex;
	tr1::unordered_map<int, int>::iterator iter = cache.find(tag);
	if (iter != cache.end()) {
		parentIndex = iter->second;
	} else {
		const char *s = dict->getString(tag);
		parentIndex = atoi(s);
		cache[tag] = parentIndex;
	}
	if (parentIndex == 0)
		return DICTIONARY_NULL;
	parentIndex--;
	return parentIndex;
//if (useCorrectTags) {
//fprintf(stderr, "%c: %d (%s) -> %d (%s)\n", useCorrectTags ? 'c' : 'h', row+1, dict->getString(wb->getFeatureValue(row, column)), parentIndex+1, dict->getString(wb->getFeatureValue(parentIndex, column)));
//}
//	return wb->getFeatureValue(parentIndex, column);
}
