/**
 * For simplicity (and performance reasons) we do not
 */

#include <config.h>

#include <stdio.h>
#include <limits>
#include <string>
#include "../common.h"
#include "FeatureFunctionPreviousVerb.h"

FeatureFunctionPreviousVerb::FeatureFunctionPreviousVerb(Dictionary *dict, WordBuffer *wb, const char *args) : FeatureFunctionRow(dict, wb) {
}

FeatureFunctionPreviousVerb::~FeatureFunctionPreviousVerb() {
}

const char *FeatureFunctionPreviousVerb::getName() {
	return "PreviousVerb()";
}

void FeatureFunctionPreviousVerb::getTagContextSize(int *min, int *max) {
	*min = std::numeric_limits<int>::min();
}

int FeatureFunctionPreviousVerb::getRow(int origRow, bool useCorrectTags) {
	for (int i = origRow-1; i >= 0; i--) {
		int tag = useCorrectTags ? wb->getCorrectTagValue(i) : wb->getProposedTagValue(i);
		if (tag == DICTIONARY_NULL)
			break;
		tr1::unordered_map<int, int>::iterator iter = cache.find(tag);
		if (iter != cache.end()) {
			if (iter->second == 0)
				continue;
		} else {
			const char *s = dict->getString(tag);
			int isVerb  = s[0] == 'V' ? 1 : 0;
			cache[tag] = isVerb;
			if (isVerb == 0)
				continue;
		}
		return i;
	}
	return std::numeric_limits<int>::min();
}
