/**
 * For simplicity (and performance reasons) we do not
 */

#include <config.h>

#include <stdio.h>
#include <string>
#include "../common.h"
#include "FeatureFunctionSubstr.h"

FeatureFunctionSubstr::FeatureFunctionSubstr(Dictionary *dict, WordBuffer *wb, const char *args) : FeatureFunctionTransform(dict, wb) {
	// get name of a function (e.g. substr)
	name = (char *)malloc(sizeof("Substr")+sizeof(args)+3);
	strcpy(name, "Substr(");
	strcat(name, args);
	strcat(name, ")");
	if (sscanf(args, "%d,%d", &a, &b) != 2) {
		a = b = -1;
		tmpBuffer = NULL;
		fprintf(stderr, "Invalid substr arguments: %s\n", args);
	}
	tmpBuffer = new char[b+1];
}

FeatureFunctionSubstr::~FeatureFunctionSubstr() {
	free(name);
	delete[] tmpBuffer;
}

const char *FeatureFunctionSubstr::getName() {
	return name;
}

int FeatureFunctionSubstr::transformValue(int value, bool useCorrectTags) {
	tr1::unordered_map<int, int>::iterator iter = cache.find(value);
	if (iter != cache.end()) {
		return iter->second;
	} else {
		int result;
		if (value == DICTIONARY_NULL) {
			result = DICTIONARY_NULL;
		} else if (value == DICTIONARY_UNKNOWN) {
			result = DICTIONARY_UNKNOWN;
		} else {
			const char *s = dict->getString(value);
			strncpy(tmpBuffer, s+a, b);
			tmpBuffer[b] = '\0';
			result = dict->getId(tmpBuffer, true);
		}
		cache[value] = result;
		return result;
	}
}
