#include <string.h>
#include "Dictionary.h"
#include "FeatureFunction.h"
#include "WordBuffer.h"
#include "FeatureFunctionLemma.h"
#include "FeatureFunctionMask.h"
#include "FeatureFunctionParentDirection.h"
#include "FeatureFunctionParent.h"
#include "FeatureFunctionPreviousVerb.h"
#include "FeatureFunctionSubstr.h"

FeatureFunction *getFeatureFunction(Dictionary *dict, WordBuffer *wb, const char *name, const char *args) {
	if (!strcmp(name, "lemma"))
		return new FeatureFunctionLemma(dict, wb, args);
	else if (!strcmp(name, "mask"))
		return new FeatureFunctionMask(dict, wb, args);
	else if (!strcmp(name, "parentdirection"))
		return new FeatureFunctionParentDirection(dict, wb, args);
	else if (!strcmp(name, "parent"))
		return new FeatureFunctionParent(dict, wb, args);
	else if (!strcmp(name, "previousverb"))
		return new FeatureFunctionPreviousVerb(dict, wb, args);
	else if (!strcmp(name, "substr"))
		return new FeatureFunctionSubstr(dict, wb, args);
	else 
		return NULL;
}
