%module Featurama

%{
#include "featurama/perc.h"
%}

%include typemaps.i

typedef struct perc PERC;

extern PERC *perc_init();
extern void perc_destroy(PERC *perc);

extern int perc_process_file_full(PERC *perc, const char *dataFile, int skipHeader);
extern int perc_process_file(PERC *perc, FILE *dataFile);

extern int perc_append_word(PERC *perc, const char *line);
extern void perc_begin_sentence(PERC *perc);
extern void perc_end_sentence(PERC *perc);

extern void perc_get_accuracy(PERC *perc, double *OUTPUT, double *OUTPUT);
extern void perc_reset_accuracy(PERC *perc);
extern const char *perc_get_proposed_tag(PERC *perc, int sentenceIndex, int index);
extern const char *perc_get_additional_proposed_tag(PERC *perc, int sentenceIndex, int index);
extern double perc_get_nbest_score(PERC *perc, int index);

extern int perc_make_features_init(PERC *perc, const char *templateFile, const char *dictFile, const char *header);
extern int perc_make_features_finish(PERC *perc, const char *featureFile, const char *dictFile, int minFreq);

extern int perc_train_init(PERC *perc, const char *featureFile, const char *dictFile, const char *alphaFile, const char *header, int prune, int order);
extern int perc_train_finish(PERC *perc, const char *dictFile, const char *alphaFile);

extern int perc_test_init(PERC *perc, const char *featureFile, const char *dictFile, const char *alphaFile, const char *header, int prune, int nbest, int order);
extern int perc_test_finish(PERC *perc);
