#!/usr/bin/perl -W
use strict;

# convert csts data file into perc format, using gangrena feature set
# usage: csts2perc-cs.pl <train|test> <csts_file >perc_file

BEGIN {
	binmode(STDIN, ":utf8");
	binmode(STDOUT, ":utf8");
	binmode(STDERR, ":utf8");
}

@ARGV == 1 or die("usage: csts2perc-cs.pl <train|test> <csts_file >perc_file");

my $add_correct = $ARGV[0] eq 'train' ? 1 : 0;

# print header
print "Form\tPrefix1\tPrefix2\tPrefix3\tPrefix4\tSuffix1\tSuffix2\tSuffix3\tSuffix4\tNum\tCap\tDash\tFollowingVerbTag\tFollowingVerbLemma\tTag\n";

my $first = 1;
my @sent = ();
my $following_index = 12;
my $form_index = 0;
my $tag_index = 14;
while (<STDIN>) {
	chomp;
	if (s/^\s*<[fd] [^>]*>// || s/^\s*<[fd]>//) {
		s/([^<]*)//;
		my ($form, $taglemma, $morph) = ($1, "NULL", $_);
		if ($morph =~ s/^\s*<l>([^<]*)<t>([^<]*)(<.*)/$3/) {
			$taglemma = "$2 $1";
		}
		my @word;
		push(@word, $form);
		push(@word, substr($form, 0, 1));
		push(@word, substr($form, 0, 2));
		push(@word, substr($form, 0, 3));
		push(@word, substr($form, 0, 4));
		push(@word, substr($form, -1, 1));
		push(@word, substr($form, -2, 2));
		push(@word, substr($form, -3, 3));
		push(@word, substr($form, -4, 4));
		push(@word, $form =~ /[0-9]/ ? 1 : 0);
		push(@word, $form =~ /[[:upper:]]/ ? 1 : 0);
		push(@word, $form =~ /-/ ? 1 : 0);
		# FollowingVerbTag & FollowingVerbLemma
		push(@word, "", "");
		push(@word, $taglemma);
		my $seen_in_offer = 0;
		while ($morph =~ s/^.*?(<MMl)/$1/) {
			$morph =~ s/^<MMl[^>]*>([^<]*)//;
			my $l = $1;
			while ($morph =~ s/^<MMt[^>]*>([^<]*)//) {
				my $tl = "$1 $l";
				push(@word, $tl);
				$seen_in_offer = 1 if ($tl eq $taglemma);
			}
		}
		push(@word, $taglemma) if ($add_correct and not $seen_in_offer);
		push(@sent, \@word);
	} elsif (/^\s*<s[ >]/) {
		next if (@sent == 0);

		my ($verb_tag, $verb_lemma) = ("NULL", "NULL");
		for (my $i = @sent-1; $i >= 0; $i--) {
			$sent[$i]->[$following_index] = $verb_tag;
			$sent[$i]->[$following_index+1] = $verb_lemma;
			for (my $j = $tag_index+1; $j < @{$sent[$i]}; $j++) {
				if (substr($sent[$i]->[$j], 0, 1) eq "V") {
					my $idx = index($sent[$i]->[$j], " ");
					$verb_tag = substr($sent[$i]->[$j], 0, $idx);
					$verb_lemma = substr($sent[$i]->[$j], $idx+1);
					last;
				}
			}
		}
		print "\n" if (not $first);
		$first = 0;
		foreach my $w (@sent) {
			print join("\t", @{$w})."\n";
		}
		@sent = ();
	}
}

if (@sent > 0) {
	my ($verb_tag, $verb_lemma) = ("NULL", "NULL");
	for (my $i = @sent-1; $i >= 0; $i--) {
		$sent[$i]->[$following_index] = $verb_tag;
		$sent[$i]->[$following_index+1] = $verb_lemma;
		for (my $j = $tag_index+1; $j < @{$sent[$i]}; $j++) {
			if (substr($sent[$i]->[$j], 0, 1) eq "V") {
				my $idx = index($sent[$i]->[$j], " ");
				$verb_tag = substr($sent[$i]->[$j], 0, $idx);
				$verb_lemma = substr($sent[$i]->[$j], $idx+1);
				last;
			}
		}
	}
	print "\n" if (not $first);
	$first = 0;
	foreach my $w (@sent) {
		print join("\t", @{$w})."\n";
	}
	@sent = ();
}
