#!/usr/bin/perl -W
use strict;

# convert csts data file into perc format, using jeremias feature set
# usage: csts2perc-en.pl <csts_file >perc_file

BEGIN {
	binmode(STDIN, ":utf8");
	binmode(STDOUT, ":utf8");
	binmode(STDERR, ":utf8");
}

# print header
print "Form\tPrefix1\tPrefix2\tPrefix3\tPrefix4\tPrefix5\tPrefix6\tPrefix7\tPrefix8\tPrefix9\tSuffix1\tSuffix2\tSuffix3\tSuffix4\tSuffix5\tSuffix6\tSuffix7\tSuffix8\tSuffix9\tNum\tCap\tDash\tTag\n";

my $first = 1;
while (<STDIN>) {
	chomp;
	if (/^\s*<[fd] [^>]*>([^<]*)<l>([^<]*)<t>([^<]*)(<.*)/) {
		my ($form, $lemma, $tag, $morph) = ($1, $2, $3, $4);
		print "$form";
		print "\t".(substr($form, 0, 1));
		print "\t".(substr($form, 0, 2));
		print "\t".(substr($form, 0, 3));
		print "\t".(substr($form, 0, 4));
		print "\t".(substr($form, 0, 5));
		print "\t".(substr($form, 0, 6));
		print "\t".(substr($form, 0, 7));
		print "\t".(substr($form, 0, 8));
		print "\t".(substr($form, 0, 9));
		print "\t".(substr($form, -1, 1));
		print "\t".(substr($form, -2, 2));
		print "\t".(substr($form, -3, 3));
		print "\t".(substr($form, -4, 4));
		print "\t".(substr($form, -5, 5));
		print "\t".(substr($form, -6, 6));
		print "\t".(substr($form, -7, 7));
		print "\t".(substr($form, -8, 8));
		print "\t".(substr($form, -9, 9));
		print "\t".($form =~ /[0-9]/ ? 1 : 0);
		print "\t".($form =~ /[[:upper:]]/ ? 1 : 0);
		print "\t".($form =~ /-/ ? 1 : 0);
		print "\t$tag";
		while ($morph =~ s/^.*?(<MMl)/$1/) {
			$morph =~ s/^<MMl[^>]*>([^<]*)//;
			while ($morph =~ s/^<MMt[^>]*>([^<]*)//) {
				print "\t$1";
			}
		}
		print "\n";
	} elsif (/^\s*<s /) {
		print "\n" if (not $first);
		$first = 0;
	}
}
