#!/usr/bin/perl -W
use strict;

# usage: perc2csts.pl perc_result <csts_file >csts_file_result

@ARGV == 1 or die("Missing result file");

# read result file
my $f;
my @result;
open($f, "<".$ARGV[0]) or die("Cannot open result file");
while (<$f>) {
	chomp;
	push(@result, $_);
}
close($f);

# read CSTS file
while (<STDIN>) {
	chomp;
	if (/<[fd][ >]/) {
		print $_;
		s/<[fd][^>]*>(.*?)(<MMl)/$2/;
		my $tag = shift(@result);
		my $lemma;
		if ($tag =~ /^([^ ]*) ([^ ]*)$/) {
			$tag = $1;
			$lemma = $2;
		} else {
			while (not defined $lemma and s/^<MMl[^>]*>([^<]*)//) {
				my $l = $1;
				while (s/^<MMt[^>]*>([^<]*)//) {
					if ($1 eq $tag) {
						$lemma = $l;
						last;
					}
				}
			}
		}
		#$lemma = $form if (not defined $lemma);
		print "<MDl src=\"f\">$lemma<MDt src=\"f\">$tag\n";
	} elsif (/<s[ >]/) {
		shift(@result);
		print $_."\n";
	} else {
		print $_."\n";
	}
}
