#!/usr/bin/env bash

# Simple script for running Czech tagger (using Collins' averaged perceptron
# algorithm). Data files must be in CSTS format (UTF-8), best scoring data
# files (according to the test data) are saved using prefix. Tagged data are
# written to the standard output in the CSTS format (UTF-8).

if [ $# -ne 2 ]; then
	echo usage: tag-csts-cs.sh prefix eval_test_data
	exit 1;
fi

TMP=/tmp

prefix=$1
test_data=$2

base=`dirname $0`

${base}/csts2perc-cs.pl test <"$test_data" >${TMP}/$$.test.data
${base}/../tag.sh "$prefix" ${TMP}/$$.test.data >${TMP}/$$.test.data.out
${base}/perc2csts.pl ${TMP}/$$.test.data.out <"$test_data"

rm -f ${TMP}/$$.test.data ${TMP}/$$.test.data.out
