#!/usr/bin/env bash

# Simple script for training English tagger using Collins' averaged perceptron
# algorithm. Data files must be in CSTS format (UTF-8), best scoring data files
# (according to the test data) are saved using prefix.

if [ $# -ne 5 ]; then
	echo usage: train-csts-en.sh iterations feature_templates train_data dev_test_data prefix
	exit 1;
fi

TMP=/tmp

iters=$1
feature_templates=$2
train_data=$3
test_data=$4
prefix=$5

base=`dirname $0`

${base}/csts2perc-en.pl <"$train_data" >${TMP}/$$.train.data
${base}/csts2perc-en.pl <"$test_data" >${TMP}/$$.test.data

${base}/../train.sh $iters "$feature_templates" ${TMP}/$$.train.data ${TMP}/$$.test.data "$prefix"

rm -f ${TMP}/$$.train.data ${TMP}/$$.test.data
