#!/usr/bin/env bash

# Simple script for testing Collins' averaged perceptron algorithm result. Data
# file must be in perc format (UTF-8). ${prefix}.f, ${prefix}.dict and
# ${prefix}.alpha are used as feature, dictionary and alpha file, respectively.

TMP=/tmp

if [ $# -lt 2 ]; then
	echo "usage: test.sh [options] prefix eval_test_data"
	exit 1;
fi

options=""
while [ $# -gt 2 ]; do
	options="$options $1"
	shift;
done

prefix=$1
test_data=$2

if which perc${TSFX} >/dev/null 2>&1; then
	base=
else
	base=`dirname $0`/../src/
fi

echo "Testing"
${base}perc${TSFX} test $options -d ${prefix}.dict -f ${prefix}.f -a ${prefix}.alpha "$test_data" 2>&1 >/dev/null|tee ${TMP}/$$.testout|grep -v "words processed, accuracy"
accuracy=`tail -n 1 ${TMP}/$$.testout | sed 's/.*accuracy: \(.*\)/\1/'`
echo $accuracy
rm -f ${TMP}/$$.testout
